<id>
Kindred:KarmaLog
</id>

<version>
1.00
</version>

<edit file>
index.php
</edit file>

<search for>
		'lock' => array('LockTopic.php', 'LockTopic'),
</search for>

<add before>
		'karma' => array('Karma.php', 'KarmaLogMain'),
</add before>

<edit file>
$sourcedir/Karma.php
</edit file>

<search for>
?>
</search for>

<add before>
// The karma log

function KarmaLogMain()
{
		global $txt, $scripturl, $sourcedir, $context, $db_prefix;

	is_admin();
  adminIndex('shop_general');

	loadTemplate('Karma');
	$context['page_title'] = $context['forum_name'] . ': Karma Log';

	// Build the linktree for all the actions...
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=karma',
		'name' => 'Karma Log'
	);

}


function log_karmaActions($max_listing = 200, $output_method = 'echo')
{

	global $db_prefix;

// Get the data from the Karma log.
$karma_result = db_query("
   SELECT lk.ID_TARGET, lk.ID_EXECUTOR, lk.logTime, lk.action, memt.realName AS targetName, meme.realName AS executorName
   FROM {$db_prefix}log2_karma AS lk, {$db_prefix}members AS memt, {$db_prefix}members AS meme
   WHERE memt.ID_MEMBER = lk.ID_TARGET
      AND meme.ID_MEMBER = lk.ID_EXECUTOR
   ORDER BY logTime DESC
   LIMIT $max_listing", __FILE__, __LINE__);

	$return = array();
	// Build an array to return karama action data.
	while ($row_karmas = mysql_fetch_assoc($karma_result))
		$return[] = array(
			'executor' => $row_karmas['executorName'],
			'target' => $row_karmas['targetName'],
			'action' => ($row_karmas['action'] == 1) ? 'applauds' : 'smites',
			'time' => timeformat($row_karmas['logTime'])
		);

	mysql_free_result($karma_result);

	// return the array?
	if ($output_method != 'echo' || empty($return))
		return $return;

	// print as html?
	foreach ($return as $data)
		echo $data['executor'], ' ', $data['action'], ' ', $data['target'], ' ', $data['time'], '<br />';

	unset($return);
}

</add before>

<search for>
		// Change by one.
		updateMemberData($_REQUEST['uid'], array($dir == 1 ? 'karmaGood' : 'karmaBad' => '+'));
</search for>

<add before>
		// and into the long term log...
		db_query("
			INSERT INTO {$db_prefix}log2_karma
				(action, ID_TARGET, ID_EXECUTOR, logTime)
			VALUES ({$dir}, {$_REQUEST[uid]}, {$ID_MEMBER}, " . time() . ')', __FILE__, __LINE__);

</add before>

<edit file>
$sourcedir/Admin.php
</edit file>

<search for>
		// Last but not least, the search log!
</search for>

<add before>
		// And the extended Karma Log
		db_query("
			DELETE FROM {$db_prefix}log2_karma", __FILE__, __LINE__);

</add before>

<edit file>
$sourcedir/Subs.php
</edit file>

<search for>
				'maintain_forum' => '<a href="' . $scripturl . '?action=maintain">' . $txt['maintain_title'] . '</a>',
</search for>

<add before>
				'view_karma_log' => '<a href="' . $scripturl . '?action=karma">' . $txt['view_karma_log'] . '</a>',
</add before>

<edit file>
$languagedir/Modifications.english.php
</edit file>

<search for>
?>
</search for>

<add before>
// Karma Log
$txt['karma_log'] = '<b>Karma Log</b>';
$txt['view_karma_log'] = 'View Karma Log';

</add before>

